<template>
  <div>
    <ModuleHeroHeader
      ref="heroheader"
      class="heroheader"
      :items="{ left: slidesLeft, right: slidesRight }"
    />

    <div v-if="ready" class="page-dates" :class="[displayOnTop ? 'z-30' : '']">
      <div v-if="dates" class="content">
        <div class="dates-ui">
          <h2>Saison</h2>

          <ModuleSlideMenu
            class="seasons-menu"
            :items="seasons"
            @change="onSeasonChange"
            :disabled="transitioning"
          />

          <ul class="shows-menu">
            <li v-for="show in shows" :key="show.id" class="list-complete-item">
              <div class="inner">
                <button
                  type="button"
                  :class="{ current: show.id === showId }"
                  @click="onShowClick(show.id)"
                  :disabled="hideList"
                >
                  {{ show.name }}
                </button>

                <nuxt-link
                  :to="`/spectacles/${show.slug}`"
                  event=""
                  @click.native="onInfoClick(`/spectacles/${show.slug}`)"
                >
                  <UiCoreVIcon name="info" class="icon" />
                </nuxt-link>
              </div>
            </li>
          </ul>
          <!-- </transition-> -->
        </div>

        <div class="dates-list" :class="{ hide: hideList }">
          <ModuleDateList v-if="dates" :dates="computedDates" />
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  async asyncData({ params, $api }) {
    const seasons = await $api.dates.getSeasons()
    const seasonId = seasons.data[seasons.data.length - 1].id
    const dates = await $api.dates.datesBySeason(seasonId)
    return {
      seasons: seasons.data || null,
      seasonId,
      dates: dates.data || null,
    }
  },
  data() {
    return {
      ready: false,
      displayOnTop: false,
      dates: null,
      hideList: false,
      nextShowId: null,
      seasons: null,
      shows: null,
      showId: null,
      seasonId: null,
      startItemsLeft: [
        {
          color: '#FF0000',
        },
      ],

      startItemsRight: [
        {
          color: 'rgba(0,0,0,0)',
        },
      ],
      showItemsRight: [
        {
          color: 'rgba(255,255,255,1)',
        },
      ],

      slidesLeft: null,
      slidesRight: null,
      transitioning: true,
    }
  },
  head() {
    return {
      title: 'Oh! Oui... Dates',
    }
  },

  computed: {
    computedDates() {
      return this.dates.filter((date) => date.show.id === this.showId)
    },
  },
  mounted() {
    if (this.dates) this.getShowsFromDates()

    this.setShowId(Number(this.$route.query.id) || this.shows[0].id)

    this.changeBackground(this.computedDates[0].show || null)

    const t = this
    setTimeout(() => {
      t.$nuxt.$emit('pageloaded', {
        title: this.$tr('menu_dates'),
      })
      t.ready = true
      t.transitioning = false
    }, 500)
  },

  beforeDestroy() {
    this.showId = null
    this.nextShowId = null
    this.transitioning = false
    this.$nuxt.$off('onContentHidden', this.onContentHidden)
    this.$nuxt.$off('onContentShow', this.onContentShow)
  },

  methods: {
    async onSeasonChange(index) {
      if (this.seasonId === this.seasons[index].id) return

      this.transitioning = true
      this.seasonId = this.seasons[index].id
      await this.loadSeasonDates()
      this.startTransitionToShow()
    },

    async loadSeasonDates(index) {
      const dates = await this.$api.dates.datesBySeason(this.seasonId)
      this.dates = dates.data

      this.getShowsFromDates()
      this.nextShowId = this.shows[0].id
    },

    onShowClick(id) {
      if (this.nextShowId === id) return
      if (this.transitioning) return

      this.nextShowId = id
      this.startTransitionToShow()
    },

    startTransitionToShow() {
      this.transitioning = true
      this.hideList = true
      this.displayOnTop = true

      this.$nuxt.$on('onContentHidden', this.onContentHidden)
      this.$nuxt.$emit('transitionStart')
    },

    setShowId(id) {
      this.showId = id
    },

    onContentHidden() {
      if (this.nextShowId) this.setShowId(this.nextShowId)

      this.hideList = false

      this.changeBackground(this.computedDates[0].show || null)

      this.$nuxt.$off('onContentHidden', this.onContentHidden)
      this.$nuxt.$on('onContentShow', this.onContentShow)

      this.$nuxt.$emit('transitionEnd')
    },

    onContentShow() {
      this.$nuxt.$off('onContentShow', this.onContentShow)
      this.transitioning = false
    },

    getShowsFromDates() {
      // get shows
      const shows = []
      for (let i = 0; i < this.dates.length; i++) {
        const show = this.dates[i].show
        if (!shows.find((el) => el.name === show.name)) shows.push(show)
      }
      this.shows = shows
    },

    changeBackground(show) {
      this.slidesLeft = show ? [show.slides_left[0]] : this.startItemsLeft
      const w = window.innerWidth

      const rightSlideItem =
        w <= 1024 ? [show.slides_right[0]] : this.showItemsRight
      this.slidesRight = show ? rightSlideItem : this.startItemsRight
    },

    onInfoClick(target) {
      this.displayOnTop = false
      this.$router.push({ path: target })
    },
  },
}
</script>

<style lang="scss" scoped>
.heroheader {
  height: 65vh;
  @screen lg {
    height: 100vh;
  }
}
.page-dates {
  @screen lg {
    @apply fixed  h-screen;
    // width: 50vw;
    // left: 50vw;
    width: 55.35vw;
    right: 0;
    top: 0;
    background: none;
  }
}

.content {
  @apply relative h-full  min-h-screen;
  @apply flex-col flex items-center text-black  flex items-center justify-start;
  @apply py-8;
  background: #fcfcfc;
  @screen lg {
    @apply pl-24  pt-16 pb-0 max-h-screen;

    mask-repeat: no-repeat;
    mask-size: 100% 100%;

    mask-image: url('/SVG/mask-right.svg');
  }

  .dates-ui {
    @apply p-0 relative text-center text-2xl flex flex-col items-center;

    h2 {
      @apply italic text-xl text-grey;
    }
    .seasons-menu {
      @apply text-2xl  relative;
      @screen xl {
        @apply pb-10;
      }
    }

    .shows-menu {
      @apply mt-10 relative flex flex-col px-10;
      &.hide {
        opacity: 0;
      }
      li {
        @apply flex flex-row justify-center items-center mb-2;

        .inner {
          @apply inline-block relative;

          a {
            @apply absolute top-0 right-0 -mr-6 float-right;
            .v-icon {
              --v-icon-size: 18px;
              vertical-align: super;
              opacity: 0.5;

              &:hover {
                opacity: 1;
              }
            }
          }
        }

        button {
          @apply uppercase text-grey font-bold inline;
          transition: color 500ms, opacity 500ms;
          outline: 0;
          border: none;
          cursor: pointer;
          -webkit-appearance: none;
          -moz-appearance: none;
          appearance: none;

          &.current {
            @apply underline text-black;
          }
          &:hover {
            @apply text-black;
          }
          &[disabled] {
            cursor: initial;
            @apply text-grey;
            opacity: 0.4;
            text-decoration: none;
          }
        }
      }
    }
  }

  .dates-list {
    @apply z-10 text-black text-center w-full;

    @screen lg {
      display: inline-block;
      overflow-y: auto;

      padding-left: 10px;
    }

    transition: opacity 400ms;
    opacity: 1;

    &.hide {
      opacity: 0;
      transition: none;
    }
  }
}
.dates-list::-webkit-scrollbar {
  width: 10px;
}

/* Track */
.dates-list::-webkit-scrollbar-track {
  background: #f1f1f1;
}

/* Handle */
.dates-list::-webkit-scrollbar-thumb {
  background: #888;
}

/* Handle on hover */
.dates-list::-webkit-scrollbar-thumb:hover {
  background: #555;
}
</style>
